Codeforces 731 C.Socks-并查集+STL(vector+map)

 
 
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Arseniy is already grown-up and independent. His mother decided to leave him alone for m days and left on a vacation. She have prepared a lot of food, left some money and washed all Arseniy's clothes.

Ten minutes before her leave she realized that it would be also useful to prepare instruction of which particular clothes to wear on each of the days she will be absent. Arseniy's family is a bit weird so all the clothes is enumerated. For example, each of Arseniy's n socks is assigned a unique integer from 1 to n. Thus, the only thing his mother had to do was to write down two integers li and ri for each of the days — the indices of socks to wear on the day i (obviously, li stands for the left foot and ri for the right). Each sock is painted in one of k colors.

When mother already left Arseniy noticed that according to instruction he would wear the socks of different colors on some days. Of course, that is a terrible mistake cause by a rush. Arseniy is a smart boy, and, by some magical coincidence, he posses k jars with the paint — one for each of k colors.

Arseniy wants to repaint some of the socks in such a way, that for each of m days he can follow the mother's instructions and wear the socks of the same color. As he is going to be very busy these days he will have no time to change the colors of any socks so he has to finalize the colors now.

The new computer game Bota-3 was just realised and Arseniy can't wait to play it. What is the minimum number of socks that need their color to be changed in order to make it possible to follow mother's instructions and wear the socks of the same color during each of m days.

Input

The first line of input contains three integers n, m and k (2 ≤ n ≤ 200 000, 0 ≤ m ≤ 200 000, 1 ≤ k ≤ 200 000) — the number of socks, the number of days and the number of available colors respectively.

The second line contain n integers c1, c2, ..., cn (1 ≤ ci ≤ k) — current colors of Arseniy's socks.

Each of the following m lines contains two integers li and ri (1 ≤ li, ri ≤ n, li ≠ ri) — indices of socks which Arseniy should wear during the i-th day.

Output

Print one integer — the minimum number of socks that should have their colors changed in order to be able to obey the instructions and not make people laugh from watching the socks of different colors.

Examples
Input
3 2 3
1 2 3
1 2
2 3
Output
2
Input
3 2 2
1 1 2
1 2
2 1
Output
0
Note

In the first sample, Arseniy can repaint the first and the third socks to the second color.

In the second sample, there is no need to change any colors.

迷之题面。。。

大体题意就是一个人穿袜子,左脚的袜子,右脚的袜子,然后要穿颜色相同的袜子,不同的怎么办呢,染色,问最少染颜色的次数。

数据第一行三个数代表有几个袜子,穿几天,几种颜色,第二行是袜子颜色,下面几行就是这些天里每天走右脚穿的袜子。例如第一组数据,1 2就是第一天左脚1右脚2,2 3是第二天左脚2,右脚3,因为两天里都有2,所以第一天染1,第二天染3,所以为2。

并查集,找出集合中穿的颜色最多的,把剩下的都染色。

代码:

#include<bits/stdc++.h>
using namespace std;
const int N=2e5+10;
int hh[N],f[N];
vector<int>p[N];                       //类似一个动态数组p[N]
int Find(int x){                       //查找根节点
    if(f[x]==x)
        return f[x];
    else
        return f[x]=Find(f[x]);
}
void gg(int a,int b){
    int x=Find(a);
    int y=Find(b);
    if(x!=y)                          //压缩
        f[x]=y;
}
int main(){
    int n,m,k,l,r,ans=0;
    scanf("%d%d%d",&n,&m,&k);
    for(int i=1;i<=n;i++){
        scanf("%d",&hh[i]);           //袜子颜色
        f[i]=i;
    }
    for(int i=1;i<=m;i++){
        scanf("%d%d",&l,&r);          //左右脚袜子
        gg(l,r);
    }
    for(int i=1;i<=n;i++)
        p[Find(i)].push_back(hh[i]);  //将颜色这个元素添加进去
    for(int i=1;i<=n;i++){
        if(p[i].size()<=1)continue;
        int maxx=-1;
        map<int,int> mp;
        mp.clear();                   //清空
        for(int j=0;j<p[i].size();j++){
            mp[p[i][j]]++;
            maxx=max(maxx,mp[p[i][j]]);
        }
        ans+=p[i].size()-maxx;
    }
    printf("%d
",ans);
    return 0;
}

(T▽T)

原文地址:https://www.cnblogs.com/ZERO-/p/7156450.html